## mir 2.3.3

=== CMakeLists.txt ===
# Copyright © 2012-2017 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 or 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>,
#              Alan Griffiths <alan@octopull.co.uk>

cmake_minimum_required(VERSION 3.16)

cmake_policy(SET CMP0015 NEW)
cmake_policy(SET CMP0022 NEW)

set(CMAKE_GCOV gcov)

project(Mir)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

set(MIR_VERSION_MAJOR 2)
set(MIR_VERSION_MINOR 3)
set(MIR_VERSION_PATCH 3)

add_definitions(-DMIR_VERSION_MAJOR=${MIR_VERSION_MAJOR})
add_definitions(-DMIR_VERSION_MINOR=${MIR_VERSION_MINOR})
add_definitions(-DMIR_VERSION_MICRO=${MIR_VERSION_PATCH})
add_definitions(-D_GNU_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)

set(MIR_VERSION ${MIR_VERSION_MAJOR}.${MIR_VERSION_MINOR}.${MIR_VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
execute_process(
  COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
  OUTPUT_VARIABLE TARGET_ARCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

option(use_debflags "Use build flags from dpkg-buildflags." OFF)
if(use_debflags)
  include (cmake/Debian.cmake)
endif()
include (cmake/EnableCoverageReport.cmake)
include (cmake/MirCommon.cmake)
include (GNUInstallDirs)
include (cmake/Doxygen.cmake)

set(build_types "None;Debug;Release;RelWithDebInfo;MinSizeRel;Coverage;AddressSanitizer;ThreadSanitizer;UBSanitizer")
# Change informational string for CMAKE_BUILD_TYPE
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "${build_types}" FORCE)
# Enable cmake-gui to display a drop down list for CMAKE_BUILD_TYPE
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${build_types}")

# Standard must be set both this way and in the flags below, to cover all cmake versions
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -std=c++17 -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")

set(MIR_FATAL_COMPILE_WARNINGS ON CACHE BOOL "Should compiler warnings fail the build")
if(MIR_FATAL_COMPILE_WARNINGS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wmismatched-tags HAS_W_MISMATCHED_TAGS)

if(HAS_W_MISMATCHED_TAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-mismatched-tags")
endif()

# GCC 7.1 fixed a bug in the ARM ABI, which results in some std::vector methods
# (among others) generating this warning.
#
# There's nothing we can do about it; everything just needs to be rebuilt with
# GCC 7.1.
check_cxx_compiler_flag(-Wpsabi HAS_W_PSABI)
if(HAS_W_PSABI)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif()

set(MIR_USE_LD ld CACHE STRING "Linker to use")
set_property(CACHE MIR_USE_LD PROPERTY STRINGS "ld;gold;lld")
if(MIR_USE_LD MATCHES "gold")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=gold")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=gold")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=gold")
endif()
if(MIR_USE_LD MATCHES "lld")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=lld")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=lld")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")
endif()

# Link time optimization allows leaner, cleaner libraries
option(MIR_LINK_TIME_OPTIMIZATION "Enables the linker to optimize binaries." OFF)
if(MIR_LINK_TIME_OPTIMIZATION)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
  if(${CMAKE_COMPILER_IS_GNUCXX})
    # clang defaults to fat LTO, but gcc needs an option to specify
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffat-lto-objects")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffat-lto-objects")
    set(CMAKE_NM "gcc-nm")
    set(CMAKE_AR "gcc-ar")
    set(CMAKE_RANLIB "gcc-ranlib")
  endif()
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES "coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs")
endif()

if(cmake_build_type_lower MATCHES "addresssanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=address")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
  if (CMAKE_COMPILER_IS_GNUCXX)
    # Work around GCC bug. It should automatically link to asan when
    # -fsanitize=address is used, but doesn't.
    #
    # Linking everything with asan is harmless and simple, so do that.
    link_libraries(asan) # Workaround for LP:1413474
  endif()
elseif(cmake_build_type_lower MATCHES "threadsanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=thread")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=thread")
  if (CMAKE_COMPILER_IS_GNUCXX)
    # Work around GCC bug. It should automatically link to tsan when
    # -fsanitize=thread is used, but doesn't.
    #
    # Linking everything with tsan is harmless and simple, so do that.
    link_libraries(tsan) # Workaround for LP:1413474
  endif()
elseif(cmake_build_type_lower MATCHES "ubsanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=undefined")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=undefined")
  # "Symbol already defined" errors occur with pre-compiled headers
  SET(MIR_USE_PRECOMPILED_HEADERS OFF CACHE BOOL "Use precompiled headers" FORCE)
  if (CMAKE_COMPILER_IS_GNUCXX)
    # Work around GCC bug. It should automatically link to asan when
    # -fsanitize=undefined is used, but doesn't.
    #
    # Linking everything with ubsan is harmless and simple, so do that.
    link_libraries(ubsan) # Workaround for LP:1413474
  endif()
  # We have inline classes as interfaces used by .so's and implemented elsewhere.
  # This results in multiple trivial implementations. So let's not warn about that.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-sanitize=vptr")
else()
  # AddressSanitizer builds fail if we disallow undefined symbols
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

# Define LOG_NDEBUG=1 to ensure Android ALOGV calls are not compiled in to
# consume CPU time...
add_definitions(-DLOG_NDEBUG=1)

enable_testing()
find_package(PkgConfig)

include_directories(include/core)
include_directories(include/common)
include_directories(include/cookie)

# Check for boost
find_package(Boost 1.48.0 COMPONENTS date_time system program_options filesystem iostreams REQUIRED)
include_directories (SYSTEM
  ${Boost_INCLUDE_DIRS}
)

option(
  MIR_DISABLE_EPOLL_REACTOR
  "Disable boost::asio's epoll implementation and switch to a select-based reactor to account for ancient kernels on ppa builders."
  OFF
)
if(MIR_DISABLE_EPOLL_REACTOR)
add_definitions(
  -DBOOST_ASIO_DISABLE_EPOLL -DBOOST_ASIO_DISABLE_KQUEUE -DBOOST_ASIO_DISABLE_DEV_POLL
)
endif(MIR_DISABLE_EPOLL_REACTOR)

add_definitions(-DEGL_NO_X11)
add_definitions(-DMESA_EGL_NO_X11_HEADERS) # Can be removed when all platforms support EGL_NO_X11

pkg_check_modules(WAYLAND_EGLSTREAM wayland-eglstream)

# Set the default platforms based on availability of NVIDIA libraries
if (WAYLAND_EGLSTREAM_FOUND)
  set(
    MIR_PLATFORM
    gbm-kms;x11;eglstream-kms;wayland
    CACHE
    STRING
    "a list of graphics backends to build (options are 'gbm-kms', 'x11', 'eglstream-kms', 'wayland', or 'rpi-dispmanx')"
  )
else()
  set(
    MIR_PLATFORM
    gbm-kms;x11;wayland
    CACHE
    STRING
    "a list of graphics backends to build (options are 'gbm-kms', 'x11', 'eglstream-kms', 'wayland', or 'rpi-dispmanx')"
  )
endif()

list(GET MIR_PLATFORM 0 MIR_TEST_PLATFORM)

option(MIR_ENABLE_TESTS "Build tests" ON)
CMAKE_DEPENDENT_OPTION(
  MIR_ENABLE_WLCS_TESTS "Also Build WLCS tests" ON
  "MIR_ENABLE_TESTS" OFF
)

foreach(platform IN LISTS MIR_PLATFORM)
  if (platform STREQUAL "gbm-kms")
    set(MIR_BUILD_PLATFORM_GBM_KMS TRUE)
  endif()
  if (platform STREQUAL "x11")
     set(MIR_BUILD_PLATFORM_X11 TRUE)
  endif()
  if (platform STREQUAL "eglstream-kms")
     if (NOT WAYLAND_EGLSTREAM_FOUND)
        message(FATAL_ERROR "EGLStream platform requested, but required NVIDIA external EGL platform nvidia-egl-wayland not found")
     endif()
     set(MIR_BUILD_PLATFORM_EGLSTREAM_KMS TRUE)
  endif()
  if (platform STREQUAL "wayland")
     set(MIR_BUILD_PLATFORM_WAYLAND TRUE)
  endif()
  if (platform STREQUAL "rpi-dispmanx")
    set(MIR_BUILD_PLATFORM_RPI_DISPMANX TRUE)
    pkg_check_modules(BCM_HOST REQUIRED bcm_host)
  endif()
endforeach(platform)

find_package(EGL REQUIRED)
find_package(GLESv2 REQUIRED)
find_package(GLM REQUIRED)
find_package(Protobuf REQUIRED )
find_package(CapnProto REQUIRED)
find_package(GLog REQUIRED)
find_package(GFlags REQUIRED)

pkg_check_modules(LTTNG_UST REQUIRED lttng-ust)
pkg_check_modules(UDEV REQUIRED libudev)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0 gio-unix-2.0)
pkg_check_modules(WAYLAND_SERVER REQUIRED wayland-server)
pkg_check_modules(WAYLAND_CLIENT REQUIRED wayland-client)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(XCB_COMPOSITE REQUIRED xcb-composite)
pkg_check_modules(XCB_XFIXES REQUIRED xcb-xfixes)
pkg_check_modules(XCB_RENDER REQUIRED xcb-render)
pkg_check_modules(X11_XCURSOR REQUIRED xcursor)
pkg_check_modules(DRM REQUIRED libdrm)

include_directories (SYSTEM ${GLESv2_INCLUDE_DIRS})
include_directories (SYSTEM ${EGL_INCLUDE_DIRS})
include_directories (SYSTEM ${GLM_INCLUDE_DIRS})

include(CheckCXXSymbolExists)
list(APPEND CMAKE_REQUIRED_INCLUDES ${DRM_INCLUDE_DIRS})
list(APPEND CMAKE_REQUIRED_LIBRARIES ${DRM_LIBRARIES})

=== src/CMakeLists.txt ===
# We need MIRPLATFORM_ABI in both libmirplatform and the platform implementations.
set(MIRPLATFORM_ABI 21)

set(MIRAL_VERSION_MAJOR 3)
set(MIRAL_VERSION_MINOR 1)
set(MIRAL_VERSION_PATCH 0)
set(MIRAL_VERSION ${MIRAL_VERSION_MAJOR}.${MIRAL_VERSION_MINOR}.${MIRAL_VERSION_PATCH})

# Add the cookie implementation before exposing any APIs
add_subdirectory(cookie/)

# We need MIR_CLIENT_PLATFORM_PATH in both libmirclient and the platform
# implementations
set(MIR_CLIENT_PLATFORM_PATH
  ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/mir/client-platform
)

# Add the core and platform implementations before exposing any private APIs
add_subdirectory(core)
add_subdirectory(platforms/)

# the src/include/... directories should be private to the implementation
include_directories(${PROJECT_SOURCE_DIR}/src/include/common)
set(MIR_GENERATED_INCLUDE_DIRECTORIES)
add_subdirectory(capnproto/)
add_subdirectory(common/)
add_subdirectory(protobuf/)
include_directories(${MIR_GENERATED_INCLUDE_DIRECTORIES})

add_subdirectory(platform/)
add_subdirectory(wayland/)
add_subdirectory(server/)
add_subdirectory(miral/)
add_subdirectory(client/)
add_subdirectory(renderer/)
add_subdirectory(renderers/)
add_subdirectory(gl/)

add_executable(wrapper wrapper.c)
target_compile_definitions(wrapper PUBLIC
    EXECUTABLE_FORMAT=\"%s.bin\"
    _DEFAULT_SOURCE
    _BSD_SOURCE)

set(
  MIR_GENERATED_INCLUDE_DIRECTORIES
  ${MIR_GENERATED_INCLUDE_DIRECTORIES}
  PARENT_SCOPE)

set(MIR_SERVER_OBJECTS ${MIR_SERVER_OBJECTS} PARENT_SCOPE)
set(MIR_SERVER_REFERENCES ${MIR_SERVER_REFERENCES} PARENT_SCOPE)
set(MIR_PLATFORM_OBJECTS ${MIR_PLATFORM_OBJECTS} PARENT_SCOPE)
set(MIR_PLATFORM_REFERENCES ${MIR_PLATFORM_REFERENCES} PARENT_SCOPE)
set(MIR_CLIENT_PLATFORM_PATH ${MIR_CLIENT_PLATFORM_PATH} PARENT_SCOPE)
set(MIR_SERVER_PLATFORM_PATH ${MIR_SERVER_PLATFORM_PATH} PARENT_SCOPE)
set(MIRSERVER_INCLUDE_DIRS ${MIRSERVER_INCLUDE_DIRS} PARENT_SCOPE)

# We need the ABI versions in the tests
set(MIR_SERVER_GRAPHICS_PLATFORM_ABI ${MIR_SERVER_GRAPHICS_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_SERVER_INPUT_PLATFORM_ABI ${MIR_SERVER_INPUT_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_SERVER_GRAPHICS_PLATFORM_VERSION ${MIR_SERVER_GRAPHICS_PLATFORM_VERSION} PARENT_SCOPE)
set(MIR_CLIENT_PLATFORM_ABI ${MIR_CLIENT_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_INPUT_PLATFORM_VERSION_SCRIPT ${MIR_INPUT_PLATFORM_VERSION_SCRIPT} PARENT_SCOPE)
set(MIR_CLIENT_PLATFORM_VERSION ${MIR_CLIENT_PLATFORM_VERSION} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
# get a gtest version string the regex will match
if (GTEST_FOUND AND GTEST_MAIN_FOUND)
  set(GTEST_VERSION_STR ${GTEST_VERSION})
  set(GTEST_DETECTION_METHOD "pkg-config")
elseif (DEFINED ENV{GTEST_VERSION})
  set(GTEST_VERSION_STR $ENV{GTEST_VERSION})
  set(GTEST_DETECTION_METHOD "GTEST_VERSION environment variable")
else()
  find_program(APT_EXECUTABLE
    NAMES "apt")
  find_program(RPM_EXECUTABLE
    NAMES "rpm")
  find_program(PACMAN_EXECUTABLE
    NAMES "pacman")
  find_program(GTEST_CONFIG_EXECUTABLE
    NAMES "gtest-config" "gtest-conf")
  if(APT_EXECUTABLE)
    EXEC_PROGRAM(${APT_EXECUTABLE} "/"
      ARGS "policy" "libgtest-dev"
      OUTPUT_VARIABLE GTEST_VERSION_STR)
    set(GTEST_DETECTION_METHOD "output of apt")
  elseif(RPM_EXECUTABLE)
    EXEC_PROGRAM(${RPM_EXECUTABLE} "/"
      ARGS "-q" "gtest-devel"
      OUTPUT_VARIABLE GTEST_VERSION_STR)
    set(GTEST_DETECTION_METHOD "output of rpm")
  elseif(PACMAN_EXECUTABLE)
    EXEC_PROGRAM(${PACMAN_EXECUTABLE} "/"
      ARGS "-Q" "gtest"
      OUTPUT_VARIABLE GTEST_VERSION_STR)
    set(GTEST_DETECTION_METHOD "output of pacman")
  elseif(GTEST_CONFIG_EXECUTABLE)
    EXEC_PROGRAM(${GTEST_CONFIG_EXECUTABLE} "/"
      ARGS "--version"
      OUTPUT_VARIABLE GTEST_VERSION_STR)
    set(GTEST_DETECTION_METHOD "output of gtest-config")
  else()
    message(WARNING "Could not detect GTest version, Assuming v1.8.0 (or compatible) and hoping for the best")
    set(GTEST_VERSION_STR "1.8.0")
    add_definitions(-DGTEST_VERSION_UNKNOWN)
    set(GTEST_DETECTION_METHOD "best guess, could not detect")
  endif()
endif()

string(REGEX MATCH
  "([0-9])\\.([0-9]+)\\.([0-9])" GTEST_VERSION_PARSED
  ${GTEST_VERSION_STR})
if (GTEST_VERSION_PARSED)
  set(GTEST_VERSION_MAJOR ${CMAKE_MATCH_1})
  set(GTEST_VERSION_MINOR ${CMAKE_MATCH_2})
  set(GTEST_VERSION_PATCH ${CMAKE_MATCH_3})
  message("Using GTest v${GTEST_VERSION_MAJOR}.${GTEST_VERSION_MINOR}.${GTEST_VERSION_PATCH} (parsed from ${GTEST_DETECTION_METHOD})")
else()
  message(WARNING "Could not parse GTest version: ${GTEST_VERSION_STR} (${GTEST_DETECTION_METHOD}), Assuming v1.8.0 (or compatible) and hoping for the best")
  set(GTEST_VERSION_MAJOR 1)
  set(GTEST_VERSION_MINOR 8)
  set(GTEST_VERSION_PATCH 0)
  add_definitions(-DGTEST_VERSION_UNKNOWN)
endif()

add_definitions(-DGTEST_VERSION_MAJOR=${GTEST_VERSION_MAJOR})
add_definitions(-DGTEST_VERSION_MINOR=${GTEST_VERSION_MINOR})
add_definitions(-DGTEST_VERSION_PATCH=${GTEST_VERSION_PATCH})

pkg_check_modules(UMOCKDEV REQUIRED umockdev-1.0>=0.6)
if (NOT UMOCKDEV_FOUND)
  message(FATAL_ERROR "Umockdev not found, cannot build without disabling tests (via MIR_ENABLE_TESTS).")
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wnull-dereference HAS_W_NULL_DEREFERENCE)
check_cxx_compiler_flag(-Woverloaded-virtual HAS_W_OVERLOADED_VIRTUAL)
check_cxx_compiler_flag(-Winconsistent-missing-override HAS_W_INCONSISTENT_MISSING_OVERRIDE)
check_cxx_compiler_flag(-Wgnu-zero-variadic-macro-arguments HAS_W_GNU_ZERO_VARIADIC_MACRO_ARGUMENTS)
check_cxx_compiler_flag(-Wno-sign-compare HAS_W_GNU_SIGN_COMPARE)

if (HAS_W_NULL_DEREFERENCE)
  # Avoid clang complaints about poor quality gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=null-dereference")
endif()
if (HAS_W_OVERLOADED_VIRTUAL)
  # Avoid clang complaints about poor quality gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=overloaded-virtual")
endif()
if (HAS_W_INCONSISTENT_MISSING_OVERRIDE)
  # MOCK_METHOD()s cannot be marked as override; we cannot consistently mark overrides
  # in the tests.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-inconsistent-missing-override")
endif()
if (HAS_W_GNU_ZERO_VARIADIC_MACRO_ARGUMENTS)
  # INSTANTIATE_TEST_SUITE_P hits this like a slice of lemon wrapped around a large gold brick.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu-zero-variadic-macro-arguments")
else()
  # GCC is a bit less flexible than clang and needs a bigger hammer...
  if (NOT MIR_USE_PRECOMPILED_HEADERS)
    # Work around the Google Test headers not being C++11 friendly (LP: #1658604)
    string(REPLACE "-pedantic" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
  endif()
endif()
if (HAS_W_GNU_SIGN_COMPARE)
  # TODO fix the code
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
endif()

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-lto")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lto")

include(CheckSymbolExists)
list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
list(APPEND CMAKE_REQUIRED_LIBRARIES "-lpthread")
string(REPLACE " -Werror " " " CMAKE_C_FLAGS ${CMAKE_C_FLAGS})    # This flag breaks check_symbol_exists()
check_symbol_exists(pthread_getname_np pthread.h HAVE_PTHREAD_GETNAME_NP)
list(REMOVE_ITEM CMAKE_REQUIRED_LIBRARIES "-lpthread")

list(APPEND CMAKE_REQUIRED_HEADERS ${GTEST_INCLUDE_DIRECTORIES})
check_cxx_symbol_exists(INSTANTIATE_TEST_SUITE_P "gtest/gtest.h" HAVE_INSTANTIATE_TEST_SUITE_P)
if (NOT HAVE_INSTANTIATE_TEST_SUITE_P)
  #GTest conveniently renamed INSTANTIATE_TEST_CASE_P and then deprecated it.
  add_definitions(-DINSTANTIATE_TEST_SUITE_P=INSTANTIATE_TEST_CASE_P)
endif()

if (MIR_BUILD_PLATFORM_GBM_KMS)
  add_definitions(-DMIR_BUILD_PLATFORM_GBM_KMS)
endif()

# public headers (only public headers should be accessed by acceptance tests)
include_directories(
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/miral
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${MIRSERVER_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/include/common
  ${PROJECT_SOURCE_DIR}/include/test
  ${PROJECT_SOURCE_DIR}/include/renderer
  ${PROJECT_SOURCE_DIR}/include/renderers/gl
)

option(MIR_BUILD_ACCEPTANCE_TESTS "Build acceptance tests" ON)
option(MIR_BUILD_INTEGRATION_TESTS "Build integration tests" ON)
option(MIR_BUILD_PERFORMANCE_TESTS "Build performance tests" ON)
option(MIR_BUILD_PRIVILEGED_TESTS "Build privileged tests" ON)
option(MIR_BUILD_UNIT_TESTS "Build unit tests" ON)
option(MIR_BUILD_PLATFORM_TEST_HARNESS "Build platform test harness" ON)

cmake_dependent_option(MIR_BUILD_INTERPROCESS_TESTS
  "Build interprocess acceptance tests as part of default testing" ON
  "MIR_BUILD_ACCEPTANCE_TESTS" OFF)


if (MIR_BUILD_ACCEPTANCE_TESTS)
  add_subdirectory(acceptance-tests/)
  add_subdirectory(umock-acceptance-tests/)
endif (MIR_BUILD_ACCEPTANCE_TESTS)

if (MIR_BUILD_PERFORMANCE_TESTS)
    add_subdirectory(performance-tests/)
endif(MIR_BUILD_PERFORMANCE_TESTS)

if (MIR_BUILD_PRIVILEGED_TESTS)
    add_subdirectory(privileged-tests/)
endif(MIR_BUILD_PRIVILEGED_TESTS)

add_subdirectory(miral)

# Private test headers used by integration and unit tests
include_directories(
  include
)

if (MIR_BUILD_INTEGRATION_TESTS)
  add_subdirectory(integration-tests/)
endif (MIR_BUILD_INTEGRATION_TESTS)

if (MIR_BUILD_UNIT_TESTS)
  add_subdirectory(unit-tests/)
endif (MIR_BUILD_UNIT_TESTS)

if (MIR_BUILD_PLATFORM_TEST_HARNESS)
  add_subdirectory(platform_test_harness/)
endif (MIR_BUILD_PLATFORM_TEST_HARNESS)

add_subdirectory(mir_test/)
add_subdirectory(mir_test_framework/)
add_subdirectory(mir_test_doubles/)
add_subdirectory(client-language/)
add_subdirectory(loader-tests/)

add_library(mir-test-assist STATIC
  $<TARGET_OBJECTS:mir-public-test>
  $<TARGET_OBJECTS:mir-public-test-doubles>
  $<TARGET_OBJECTS:mir-public-test-framework>
)

target_link_libraries(mir-test-assist
PUBLIC
  mirclient
  miral
  mirserver

  ${Boost_LIBRARIES}
  ${GTEST_BOTH_LIBRARIES}
PRIVATE
  ${GMOCK_MAIN_LIBRARY}
  ${GMOCK_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
)

mir_add_memcheck_test()
mir_add_detect_fd_leaks_test()

=== examples/example-server-lib/CMakeLists.txt ===
find_package(PIL REQUIRED)
pkg_check_modules(FREETYPE freetype2 REQUIRED)

add_library(example-shell-lib STATIC
    tiling_window_manager.cpp   tiling_window_manager.h
    floating_window_manager.cpp floating_window_manager.h
    decoration_provider.cpp     decoration_provider.h
    wallpaper_config.cpp        wallpaper_config.h
        splash_session.h
    sw_splash.cpp               sw_splash.h
    wayland_app.cpp             wayland_app.h
    wayland_surface.cpp         wayland_surface.h
    wayland_shm.cpp             wayland_shm.h
)

target_include_directories(example-shell-lib
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${PROJECT_SOURCE_DIR}/include/client
    PRIVATE
        ${FREETYPE_INCLUDE_DIRS}
)
target_link_libraries(example-shell-lib PUBLIC miral PRIVATE ${WAYLAND_CLIENT_LIBRARIES} ${FREETYPE_LIBRARIES})

=== examples/mir_demo_server/CMakeLists.txt ===
add_library(exampleserverconfig STATIC
  server_example_input_device_config.cpp
  server_example_input_event_filter.cpp
  server_example_log_options.cpp
  server_example_input_filter.cpp
  server_example_host_lifecycle_event.cpp
)

target_link_libraries(exampleserverconfig
  mirserver
  mirwayland
)

include_directories(
  ${PROJECT_SOURCE_DIR}/include/miral
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/renderers/gl
  ${PROJECT_SOURCE_DIR}/include/renderers/sw
  ${GL_INCLUDE_DIRS}
)

mir_add_wrapped_executable(mir_demo_server
    server_example.cpp
    glog_logger.cpp
    server_example_test_client.cpp
)

target_link_libraries(mir_demo_server
  example-shell-lib
  exampleserverconfig
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
  ${Boost_LIBRARIES}
)

=== src/client/CMakeLists.txt ===
find_package(XKBCOMMON REQUIRED)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
  ${PROJECT_SOURCE_DIR}/include/client/mir_toolkit/version.h
)

include_directories(
  ${PROTOBUF_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/src/include/client
  ${PROJECT_SOURCE_DIR}/src/include/cookie
  ${DRM_INCLUDE_DIRS}
)

set(MIRCLIENT_ABI 10)
set(symbol_map ${CMAKE_SOURCE_DIR}/src/client/symbols.map)

add_definitions(-DMIR_CLIENT_PLATFORM_PATH="${MIR_CLIENT_PLATFORM_PATH}/")
add_definitions(-DCLIENT_PLATFORM_VERSION="${MIR_CLIENT_PLATFORM_VERSION}")
add_definitions(-DMIR_LOG_COMPONENT_FALLBACK="mirclient")

set(MIR_CLIENT_SOURCES)
set(MIR_CLIENT_REFERENCES mircommon)

add_subdirectory(rpc/)
add_subdirectory(lttng/)
add_subdirectory(events)
add_subdirectory(input)

add_library(mirclientobjects OBJECT

  display_configuration.cpp
  drag_and_drop.cpp drag_and_drop.h
  error_connections.cpp
  event.cpp
  event_printer.cpp
  mir_blob.cpp
  mir_cookie.cpp
  mir_connection.cpp
  mir_connection_api.cpp
  mir_input_device_api.cpp
  mir_wait_handle.cpp
  mir_wait_api.cpp
  mir_surface.cpp
  mir_surface_api.cpp
  logging/rpc_report.cpp
  logging/input_receiver_report.cpp
  logging/perf_report.cpp
  default_connection_configuration.cpp
  connection_surface_map.cpp
  frame_clock.cpp
  mir_screencast.cpp
  mir_screencast_api.cpp
  mir_cursor_api.cpp
  mir_prompt_session.cpp
  mir_prompt_session_api.cpp
  mir_event_distributor.cpp
  probing_client_platform_factory.cpp
  periodic_perf_report.cpp
  buffer_stream.cpp
  screencast_stream.cpp
  buffer_vault.cpp
  mir_buffer_stream_api.cpp
  error_stream.cpp
  error_render_surface.cpp
  buffer.cpp
  error_buffer.cpp
  mir_render_surface_api.cpp
  render_surface.cpp
  presentation_chain.cpp
  mir_presentation_chain_api.cpp
  mir_buffer_api.cpp
  display_configuration_api.cpp
  protobuf_to_native_buffer.cpp
  buffer_factory.cpp
  mir_error.cpp
  mir_error.h
  mir_error_api.cpp
  buffer_stream_configuration.cpp
  error_handler.h
  ${MIR_CLIENT_SOURCES}
  ${CMAKE_SOURCE_DIR}/include/client/mir_toolkit/mir_display_configuration.h
  ${CMAKE_SOURCE_DIR}/include/client/mir_toolkit/mir_error.h
  mir_extension_core.cpp
  ${CMAKE_SOURCE_DIR}/include/client/mir_toolkit/mir_extension_core.h
  ${CMAKE_SOURCE_DIR}/include/client/mir_toolkit/extensions/drag_and_drop.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/blob.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/cookie.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/window_spec.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/window_id.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/connection.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/display_config.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/window.h
  ${CMAKE_SOURCE_DIR}/include/client/mir/client/event.h
)

# Ensure protobuf C++ headers have been produced before
# trying to compile mirclientobjects
add_dependencies(mirclientobjects mirprotobuf)
add_dependencies(mirclientobjects mircapnproto)

add_library(mirclient SHARED $<TARGET_OBJECTS:mirclientobjects> $<TARGET_OBJECTS:mirsharedinput> $<TARGET_OBJECTS:mirclientrpc>)

set_target_properties(mirclient

  PROPERTIES
  SOVERSION ${MIRCLIENT_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
)

set(LINKS
  mircommon
  mirprotobuf
  mircookie

  ${XKBCOMMON_LIBRARIES}
)

target_link_libraries(mirclient
  LINK_PRIVATE
  mirclientlttng-static
  LINK_PUBLIC
  ${MIR_CLIENT_REFERENCES}
  ${LINKS}
)

install(
  TARGETS mirclient
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(MIRCLIENT_DEBUG_EXTENSION_ABI 1)
set(debug_symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols-debug.map)

=== src/common/CMakeLists.txt ===
add_definitions(-DMIR_LOG_COMPONENT_FALLBACK="mircommon")

set(MIR_COMMON_SOURCES)
set(MIR_COMMON_REFERENCES)

include_directories(${MIR_GENERATED_INCLUDE_DIRECTORIES})

add_subdirectory(fd)
add_subdirectory(events)
add_subdirectory(logging)
add_subdirectory(report/lttng)
add_subdirectory(env)
add_subdirectory(sharedlibrary)
add_subdirectory(thread)
add_subdirectory(time)
add_subdirectory(dispatch)

list(APPEND MIR_COMMON_SOURCES
  $<TARGET_OBJECTS:mirevents>
  $<TARGET_OBJECTS:mirtime>
  ${CMAKE_CURRENT_SOURCE_DIR}/output_type_names.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/libname.cpp
  ${PROJECT_SOURCE_DIR}/include/common/mir/libname.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/posix_rw_mutex.h
  posix_rw_mutex.cpp
  edid.cpp
)

set(
  MIR_GENERATED_INCLUDE_DIRECTORIES
  ${MIR_GENERATED_INCLUDE_DIRECTORIES}
  PARENT_SCOPE)

# TODO we need a place to manage ABI and related versioning but use this as placeholder
set(MIRCOMMON_ABI 7)
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

add_library(mircommon SHARED
  input/mir_input_config.cpp
  input/mir_input_config_serialization.cpp
  input/mir_touchpad_config.cpp
  input/mir_pointer_config.cpp
  input/mir_keyboard_config.cpp
  input/mir_touchscreen_config.cpp
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_input_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_pointer_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_touchpad_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_touchscreen_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_keyboard_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_input_config_serialization.h
  ${MIR_COMMON_SOURCES}
)

target_link_libraries(mircommon
  mircapnproto
  mircore
  ${MIR_COMMON_REFERENCES}
)

add_dependencies(mircommon mircapnproto)

set_target_properties(mircommon

  PROPERTIES
  SOVERSION ${MIRCOMMON_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
)

install(TARGETS mircommon LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/common/mir
  DESTINATION "include/mircommon"
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/mircommon.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/mircommon.pc
    @ONLY
)
install(FILES       ${CMAKE_CURRENT_BINARY_DIR}/mircommon.pc    DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")

=== src/cookie/CMakeLists.txt ===
pkg_check_modules(NETTLE REQUIRED nettle)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mircookie.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mircookie.pc
  @ONLY
)

include_directories(
  ${PROJECT_SOURCE_DIR}/src/include/cookie
  ${PROJECT_SOURCE_DIR}/include/cookie
  ${NETTLE_INCLUDE_DIRS}
)

set(MIRCOOKIE_ABI 2)
set(symbol_map ${CMAKE_SOURCE_DIR}/src/cookie/symbols.map)

add_library(mircookie SHARED
  authority.cpp
  const_memcmp.cpp
  hmac_cookie.cpp
)

set_target_properties(mircookie
  PROPERTIES
  SOVERSION ${MIRCOOKIE_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
)

target_link_libraries(mircookie
  ${NETTLE_LDFLAGS} ${NETTLE_LIBS}
)

install(
  TARGETS mircookie
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/cookie/mir
  DESTINATION "include/mircookie"
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mircookie.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/core/CMakeLists.txt ===
set(MIRCORE_ABI 1)

# We don't need libmircore to have an unused dependency on libpthread
string (REPLACE " -pthread " " " CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})

add_library(mircore SHARED
    anonymous_shm_file.cpp
    fatal.cpp
    fd.cpp
    depth_layer.cpp
    geometry/rectangle.cpp
    geometry/rectangles.cpp
    geometry/ostream.cpp
    ${PROJECT_SOURCE_DIR}/include/core/mir/anonymous_shm_file.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/int_wrapper.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/optional_value.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/fatal.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/fd.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/length.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/rectangle.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/point.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/rectangles.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/displacement.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/size.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/forward.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/dimensions.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/shm_file.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/depth_layer.h
    ${PROJECT_SOURCE_DIR}/include/core/mir_toolkit/common.h
    ${PROJECT_SOURCE_DIR}/include/core/mir_toolkit/mir_version_number.h
)

target_link_libraries(
  mircore

  ${Boost_SYSTEM_LIBRARY}
)

set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

set_target_properties(mircore
    PROPERTIES
    SOVERSION ${MIRCORE_ABI}
    LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
    LINK_DEPENDS ${symbol_map}
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/mircore.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/mircore.pc
    @ONLY
)

install(TARGETS mircore LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
    DIRECTORY ${CMAKE_SOURCE_DIR}/include/core/mir ${CMAKE_SOURCE_DIR}/include/core/mir_toolkit
    DESTINATION "include/mircore"
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/mircore.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/miral/CMakeLists.txt ===
include_directories(
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/src/include/server
)

set(MIRAL_ABI 4)
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)
set(miral_include ${PROJECT_SOURCE_DIR}/include/miral)

pkg_check_modules(YAML REQUIRED yaml-cpp)
pkg_check_modules(GIO REQUIRED gio-2.0 gio-unix-2.0)

add_library(mirclientcpp INTERFACE)

add_definitions(-DMIR_LOG_COMPONENT_FALLBACK="miral" -DMIRAL_ENABLE_DEPRECATIONS=0)

add_library(miral-internal STATIC
    active_outputs.cpp                  active_outputs.h
    application_info_internal.cpp       application_info_internal.h
    basic_window_manager.cpp            basic_window_manager.h window_manager_tools_implementation.h
    coordinate_translator.cpp           coordinate_translator.h
    display_configuration_listeners.cpp display_configuration_listeners.h
    launch_app.cpp                      launch_app.h
    mru_window_list.cpp                 mru_window_list.h
    open_desktop_entry.cpp              open_desktop_entry.h
    static_display_config.cpp           static_display_config.h
    window_info_internal.cpp            window_info_internal.h
    window_management_trace.cpp         window_management_trace.h
    xcursor_loader.cpp                  xcursor_loader.h
    xcursor.c                           xcursor.h
                                        join_client_threads.h
                                        window_info_defaults.h
)

# Already implied by the linker's symbol version script, but can avoid accidents
set_target_properties(miral-internal
    PROPERTIES COMPILE_FLAGS "${CMAKE_CXXFLAGS}  -fvisibility=hidden")

set_source_files_properties(xcursor.c PROPERTIES COMPILE_DEFINITIONS _GNU_SOURCE)

check_cxx_compiler_flag(-Wstringop-truncation HAS_W_STRINGOP_TRUNCATION)
if (HAS_W_STRINGOP_TRUNCATION)
    set_source_files_properties(xcursor.c PROPERTIES
        COMPILE_FLAGS "-Wno-error=stringop-truncation"
    )
endif()

add_library(miral SHARED
    add_init_callback.cpp               ${miral_include}/miral/add_init_callback.h
    application.cpp                     ${miral_include}/miral/application.h
    application_authorizer.cpp          ${miral_include}/miral/application_authorizer.h
    application_info.cpp                ${miral_include}/miral/application_info.h
    canonical_window_manager.cpp        ${miral_include}/miral/canonical_window_manager.h
    command_line_option.cpp             ${miral_include}/miral/command_line_option.h
    cursor_theme.cpp                    ${miral_include}/miral/cursor_theme.h
    display_configuration.cpp           ${miral_include}/miral/display_configuration.h
    external_client.cpp                 ${miral_include}/miral/external_client.h
    keymap.cpp                          ${miral_include}/miral/keymap.h
    minimal_window_manager.cpp          ${miral_include}/miral/minimal_window_manager.h
    runner.cpp                          ${miral_include}/miral/runner.h
    display_configuration_option.cpp    ${miral_include}/miral/display_configuration_option.h
    output.cpp                          ${miral_include}/miral/output.h
    append_event_filter.cpp             ${miral_include}/miral/append_event_filter.h
    wayland_extensions.cpp              ${miral_include}/miral/wayland_extensions.h
    window.cpp                          ${miral_include}/miral/window.h
    window_info.cpp                     ${miral_include}/miral/window_info.h
    window_management_options.cpp       ${miral_include}/miral/window_management_options.h
    window_specification.cpp            ${miral_include}/miral/window_specification.h
    internal_client.cpp                 ${miral_include}/miral/internal_client.h
    set_command_line_handler.cpp        ${miral_include}/miral/set_command_line_handler.h
    set_terminator.cpp                  ${miral_include}/miral/set_terminator.h
    set_window_management_policy.cpp    ${miral_include}/miral/set_window_management_policy.h
    toolkit_event.cpp                   ${miral_include}/miral/toolkit_event.h
    window_management_policy.cpp        ${miral_include}/miral/window_management_policy.h
    window_manager_tools.cpp            ${miral_include}/miral/window_manager_tools.h
                                        ${miral_include}/miral/lambda_as_function.h
    x11_support.cpp                     ${miral_include}/miral/x11_support.h
    zone.cpp                            ${miral_include}/miral/zone.h
)

#include <mir/udev/wrapper.h>
set_source_files_properties(keymap.cpp PROPERTIES COMPILE_FLAGS "-I${PROJECT_SOURCE_DIR}/src/include/platform")

check_cxx_compiler_flag(-Wno-attribute-alias HAS_W_NO_ATTRIBUTE_ALIAS)
if(HAS_W_NO_ATTRIBUTE_ALIAS)
    set_source_files_properties(
            canonical_window_manager.cpp
            internal_client.cpp
            set_window_management_policy.cpp
            window_info.cpp
            window_management_policy.cpp
            window_manager_tools.cpp
            PROPERTIES COMPILE_FLAGS "${CMAKE_CXXFLAGS} -Wno-attribute-alias")
endif()

target_include_directories(mirclientcpp
    INTERFACE "${miral_include}" ${MIRCLIENT_INCLUDE_DIRS}
)

target_include_directories(miral-internal
    PRIVATE "${miral_include}" ${MIRCLIENT_INCLUDE_DIRS}
    PRIVATE ${MIRSERVER_INCLUDE_DIRS} ${GIO_INCLUDE_DIRS}
)

target_link_libraries(miral-internal
    PRIVATE
        mirserver
        ${WAYLAND_CLIENT_LDFLAGS} ${WAYLAND_CLIENT_LIBRARIES}
        ${YAML_LIBRARIES}
        ${GIO_LIBRARIES}
)

target_include_directories(miral
    PUBLIC  "${miral_include}" ${MIRCLIENT_INCLUDE_DIRS}
    PRIVATE ${MIRSERVER_INCLUDE_DIRS}
)

target_link_libraries(miral
    PUBLIC
        mircommon
    PRIVATE
        mirclient
        miral-internal
        mirserver
)

set_target_properties(miral
        PROPERTIES
        SOVERSION ${MIRAL_ABI}
        LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
)



if (CMAKE_COMPILER_IS_GNUCXX   AND  # clang generates slightly different symbols (but we don't care)
    MIR_LINK_TIME_OPTIMIZATION AND  # g++ generates slightly different symbols without LTO (but we don't care)
    EXISTS /etc/debian_version)     # Using dpkg-gensymbols only makes sense on Debian based distros

    find_program(MIR_DPKG_GENSYMBOLS dpkg-gensymbols)
    if (MIR_DPKG_GENSYMBOLS)
        add_custom_target(check-miral-symbols ALL
            DEPENDS miral ${PROJECT_SOURCE_DIR}/debian/libmiral${MIRAL_ABI}.symbols
            COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/check-and-update-debian-symbols.py ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} miral ${MIRAL_VERSION} ${MIRAL_ABI}
            WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
            VERBATIM)
    endif()
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/miral.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/miral.pc
    @ONLY
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${miral_include}/miral/version.h
)

if(TARGET doc)
    add_custom_target(regenerate-miral-symbols-map
            ${CMAKE_CURRENT_SOURCE_DIR}/regenerate-miral-symbols-map.py ${CMAKE_BINARY_DIR}/doc/xml/*.xml > ${symbol_map}
            DEPENDS doc)
endif()

install(TARGETS     miral                           LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}")
install(DIRECTORY   ${CMAKE_SOURCE_DIR}/include/miral       DESTINATION "${CMAKE_INSTALL_PREFIX}/include")
install(FILES       ${CMAKE_CURRENT_BINARY_DIR}/miral.pc    DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")

=== src/platform/CMakeLists.txt ===
add_definitions(-DMIR_LOG_COMPONENT_FALLBACK="mirplatform")

include_directories(
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/src/include/platform
)

set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

add_definitions(-DMIR_SERVER_PLATFORM_PATH="${MIR_SERVER_PLATFORM_PATH}")
add_definitions(-DMIR_SERVER_GRAPHICS_PLATFORM_VERSION="${MIR_SERVER_GRAPHICS_PLATFORM_VERSION}")

set(MIR_PLATFORM_OBJECTS
  $<TARGET_OBJECTS:mirplatformgraphicscommon>
  $<TARGET_OBJECTS:miroptions>
  $<TARGET_OBJECTS:mirudev>
)

set(MIR_PLATFORM_REFERENCES
  ${EGL_LDFLAGS} ${EGL_LIBRARIES}
  ${GL_LDFLAGS} ${GL_LIBRARIES}
  mirwayland
)

function(add_object_library_to_target TARGET OBJECT_LIB)
    get_target_property(HEADERS ${OBJECT_LIB} INTERFACE_INCLUDE_DIRECTORIES)
    get_target_property(LIBS ${OBJECT_LIB} INTERFACE_LINK_LIBRARIES)

    if (HEADERS)
        target_include_directories(${TARGET} PUBLIC ${HEADERS})
    endif()

    if (LIBS)
        target_link_libraries(${TARGET} INTERFACE ${LIBS})
    endif()

    target_sources(${TARGET} PRIVATE $<TARGET_OBJECTS:${OBJECT_LIB}>)
endfunction()

function(add_object_libraries_to_target TARGET)
    foreach(OBJECT_LIB ${ARGN})
        add_object_library_to_target(${TARGET} ${OBJECT_LIB})
    endforeach()
endfunction()

add_subdirectory(graphics/)
add_subdirectory(options)
add_subdirectory(udev)

set(MIR_PLATFORM_OBJECTS ${MIR_PLATFORM_OBJECTS} PARENT_SCOPE)
set(MIR_PLATFORM_REFERENCES ${MIR_PLATFORM_REFERENCES} PARENT_SCOPE)

add_library(mirplatform SHARED
  ${PROJECT_SOURCE_DIR}/include/platform/mir/input/input_sink.h
  ${PROJECT_SOURCE_DIR}/include/platform/mir/console_services.h
  ${PROJECT_SOURCE_DIR}/include/platform/mir/executor.h
)

add_object_libraries_to_target(
  mirplatform

  mirplatformgraphicscommon
  miroptions
  mirudev
)

target_link_libraries(mirplatform
  PRIVATE
    mircommon
    ${MIR_PLATFORM_REFERENCES}
)

set_target_properties(
  mirplatform

  PROPERTIES
  SOVERSION ${MIRPLATFORM_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
)

install(TARGETS mirplatform LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirplatform.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirplatform.pc
  @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mirplatform.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/platforms/CMakeLists.txt ===
# This needs to change whenever the ABI between the platform
# modules and the server changes in an incompatible way.
# This ABI is much smaller than the full libmirplatform ABI.
#
# TODO: Add an extra driver-ABI check target.
set(MIR_SERVER_INPUT_PLATFORM_ABI 8)
set(MIR_SERVER_INPUT_PLATFORM_STANZA_VERSION 0.27)
set(MIR_SERVER_INPUT_PLATFORM_ABI ${MIR_SERVER_INPUT_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_SERVER_INPUT_PLATFORM_VERSION "MIR_INPUT_PLATFORM_${MIR_SERVER_INPUT_PLATFORM_STANZA_VERSION}")
set(MIR_SERVER_INPUT_PLATFORM_VERSION ${MIR_SERVER_INPUT_PLATFORM_VERSION} PARENT_SCOPE)
set(MIR_SERVER_GRAPHICS_PLATFORM_ABI 19)
set(MIR_SERVER_GRAPHICS_PLATFORM_STANZA_VERSION 2.2)
set(MIR_SERVER_GRAPHICS_PLATFORM_ABI ${MIR_SERVER_GRAPHICS_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_SERVER_GRAPHICS_PLATFORM_VERSION "MIR_GRAPHICS_PLATFORM_${MIR_SERVER_GRAPHICS_PLATFORM_STANZA_VERSION}")
set(MIR_SERVER_GRAPHICS_PLATFORM_VERSION ${MIR_SERVER_GRAPHICS_PLATFORM_VERSION} PARENT_SCOPE)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/input_platform_symbols.map.in 
    ${CMAKE_CURRENT_BINARY_DIR}/input_platform_symbols.map)
set(MIR_INPUT_PLATFORM_VERSION_SCRIPT 
    ${CMAKE_CURRENT_BINARY_DIR}/input_platform_symbols.map)
set(MIR_INPUT_PLATFORM_VERSION_SCRIPT ${MIR_INPUT_PLATFORM_VERSION_SCRIPT} PARENT_SCOPE)

set(MIR_SERVER_PLATFORM_PATH
  ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/mir/server-platform
)
set(MIR_SERVER_PLATFORM_PATH
  ${MIR_SERVER_PLATFORM_PATH}
  PARENT_SCOPE
)

set(MIR_CLIENT_PLATFORM_ABI 5)
set(MIR_CLIENT_PLATFORM_STANZA_VERSION 5)
set(MIR_CLIENT_PLATFORM_ABI ${MIR_CLIENT_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_CLIENT_PLATFORM_VERSION "MIR_CLIENT_PLATFORM_${MIR_CLIENT_PLATFORM_STANZA_VERSION}")
set(MIR_CLIENT_PLATFORM_VERSION ${MIR_CLIENT_PLATFORM_VERSION} PARENT_SCOPE)

set(server_common_include_dirs
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/renderers/gl
  ${PROJECT_SOURCE_DIR}/include/renderers/sw
)

# TODO platform implementations shouldn't depend on private APIs
set(server_common_include_dirs
  ${server_common_include_dirs}
  ${CMAKE_CURRENT_SOURCE_DIR}/common/server
  ${PROJECT_SOURCE_DIR}/src/include/platform
)

set(server_symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/common/server/symbols.map)

set(client_common_include_dirs
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/client
  ${CMAKE_CURRENT_SOURCE_DIR}/common/client
)

# TODO client platform implementations shouldn't depend on private APIs
# - only needed for Hardware Buffer Stream in gbm-kms client
set(client_common_include_dirs
  ${client_common_include_dirs}
  ${PROJECT_SOURCE_DIR}/src/include/client
)

add_subdirectory(common/)

if (MIR_BUILD_PLATFORM_GBM_KMS)
    add_subdirectory(gbm-kms/)
endif()

if (MIR_BUILD_PLATFORM_X11)
    add_subdirectory(x11/)
endif()

if (MIR_BUILD_PLATFORM_EGLSTREAM_KMS)
  add_subdirectory(eglstream-kms)
endif()

if (MIR_BUILD_PLATFORM_WAYLAND)
  add_subdirectory(wayland)
endif()

if (MIR_BUILD_PLATFORM_RPI_DISPMANX)
  add_subdirectory(rpi-dispmanx)
endif()

add_subdirectory(evdev/)

=== debian/changelog ===
mir (2.3.3-0ubuntu1) hirsute; urgency=medium

  * New upstream release 2.3.3
    - Add `app-env-amend` configuration option. (Fixes: #1934)
    - [miral-terminal] wait for gnome-terminal-server to exit
    - Fix mirplatform.pc include dirs
    - Add missing <cstring> header for strdup
    - [Wayland] Do not suppress motion events when relative motion is used
      (Fixes #1959)
    - Fix protobuf symbols for Arch (Fixes FTBFS on Arch)

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Tue, 30 Mar 2021 17:03:17 +1100

mir (2.3.2-0ubuntu1) hirsute; urgency=medium

  * New upstream release 2.3.2
    - ABI summary:
      . mirclient ABI unchanged at 10
      . miral ABI unchanged at 4
      . mirserver ABI unchanged at 54
      . mircommon ABI unchanged at 7
      . mirplatform ABI unchanged at 20
      . mirprotobuf ABI unchanged at 3
      . mirplatformgraphics ABI unchanged at 18
      . mirinputplatform ABI bumped to 8
      . mircore ABI unchanged at 1
      . mircookie ABI unchanged at 2
      . mirwayland ABI bumped to 2
    - Enhancements:
      . First pass at copy/paste between Wayland and XWayland
      . Hint to Firefox that it should use Wayland when launched by miral
      . [Error handling] Report information from nested exceptions
      . Use standard key repeat values
      . [platforms] Enable linux-dmabuf on X11 and Wayland platforms
      . [platforms/linux-dmabuf] Support the full range of driver-exposed
        formats
      . [platforms/gbm-kms] Don't warn about being unable to find the current
        mode of disconnected outputs
      . [platforms/gbm-kms] Log exceptions in probe better
      . [miral] Document miral::Window
      . [miral] Document miral::display_configuration_options()
      . [miral-kiosk] Allow wayland extensions to be configured in kiosks (and
        enable pointer confinement by default)
      . [Wayland] Enable xdg_output_unstable_v1 by default
      . [Mir-on-X] Improve HiDPI support for XWayland
      . [mir-shell] Improve launching of GNOME Terminal.
    - Bugs fixed:
      . Print help text to stdout instead of stderr. (Fixes #1043)
      . [Wayland] Send sub-pixel input events to clients (Fixes: ##1814, #1828)
      . [miral] Clamp window resize to min/max. (Fixes #1821)
      . [miral] Shrink initially maximized windows on restore. (Fixes #1817)
      . [Wayland] Better help message when WAYLAND_DISPLAY in use.
        (Fixes: #1851)
      . [platforms] Disable natural scrolling on the X11 and libinput platforms.
        (Fixes #1813)
      . [miral-app] Use mktemp instead of deprecated tempfile (Fixes #1924)
  * debian/control:
    - Drop no-longer-necessary boost-thread-dev B-D
  * debian/patches/increase-display-test-timeout.patch:
  * debian/patches/disable-stringop-truncation.patch:
    - Drop patch; included in new upstream
  * debian/tests/wlcs:
    - Temporarily exclude tests Mir is known to fail

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Tue, 16 Feb 2021 11:08:45 +1100

mir (2.2.0-0ubuntu2) hzirsute; urgency=medium

  * debian/patches/disable-stringop-truncation.patch:
    - Disable -Werror=stringop-truncation on imported xcursor.c file. This
      trggers on s390x (and only s390x?), but the code appears safe.
      Fixes FTBFS on s390x (LP: #1889166)
  * debian/patches/increase-display-test-timeout.patch:
    - Standardise test timeouts to 60s (increased from 10s) in the
      DisplayConfiguratonTest acceptance tests. These inconsistently fail on
      the Launchpad builders on slow architectures (notably arm64 and armhf).

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Thu, 17 Dec 2020 10:44:50 +1100

mir (2.2.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release. Changes since 1.7.1:
    - ABI summary:
      + mirclient ABI bumped to 10
      + miral ABI bumped to 4
      + mirserver ABI bumped to 54
      + mircommon ABI unchanged at 7
      + mirplatform ABI bumped to 21
      + mirprotobuf ABI unchanged at 3
      + mirplatformgraphics ABI bumped to 19
      + mirinputplatform ABI unchanged at 7
      + mirclientplatform dropped
      + mircore ABI unchanged at 1
      + mircookie ABI unchanged at 2
    - Enhancements:
      + Add logical output group (aka "display wall") support
      + [X11] Pick up min/max size
      + [wayland] Allow adding and dropping Wayland extensions
      + [performance-tests] Use a EGL visual with no alpha channel
      + [wayland] More correct handling of DRM_FORMAT_MOD_INVALID
      + [debian] Add metapackages for each of the graphics platforms
      + [miral-app] more robust launcher script
      + [gbm-kms] Implement composite-bypass for Wayland clients
      + Minimize locking in KeyRepeatDispatcher
      + Unbreak offscreen renderer for EGL versions 1.5+
      + gbm-kms: Support zwp_linux_dmabuf_unstable_v1
        (Closes: #1663)
      + performance: do not fail performance tests unless there is no result
      + performance: Add HostedGLMark2Wayland performance tests
      + New mir-wlcs-integration package
      + [Wayland] Report rotated output sizes (a workaround until we correctly
        support transforms for outputs and surfaces)
      + [Wayland] Implement zwlr_layer_shell_v1 version 3
      + [Wayland] Implement wlr_foreign_toplevel_management_unstable_v1
      + Log SIGHUP and other signals
      + [X11] Create event dispatcher before running server.
        (Related to #1722 and #1723)
      + [X11] Manage X11 windows that existed before window manager started.
        (Related to #1722 and #1723)
      + Drop legacy packages: libmirclient-dev, mir-client-platform*, mir-utils,
        libmirserver-dev and mirtest-dev
      + Drop legacy config options: "host-socket", "nested-passthrough" & "name"
      + [mirclient] Drop obsolete stuff we don't use
      + [graphics] Reworked graphics platform API
      + [graphics] Improved probing of egmstreams-kms platform
      + [graphics] Improved probing of gbm-kms platform


=== debian/control ===
Source: mir
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Voß <thomas.voss@canonical.com>
Build-Depends: cmake,
               pkg-config,
               debhelper-compat (= 13),
               doxygen,
               xsltproc,
               graphviz,
               libboost-dev,
               libboost-date-time-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-filesystem-dev,
               protobuf-compiler,
               libdrm-dev,
               libegl1-mesa-dev,
               libgles2-mesa-dev,
               libgbm-dev,
               libglm-dev,
               libprotobuf-dev,
               libgoogle-glog-dev,
               liblttng-ust-dev,
               libxkbcommon-dev (>= 0.5),
               libumockdev-dev (>= 0.6),
               umockdev (>= 0.8.7),
               libudev-dev,
               libgtest-dev,
               google-mock (>= 1.6.0+svn437),
               libxml++2.6-dev,
# only enable valgrind once it's been tested to work on each architecture:
               valgrind [amd64 i386 armhf arm64],
               libglib2.0-dev,
               libfreetype6-dev,
               libevdev-dev,
               libinput-dev (>= 0.21),
               uuid-dev,
               python3:any,
               dh-python,
               nettle-dev,
               libcapnp-dev,
               capnproto,
               libepoxy-dev,
               python3-pil:native,
               linux-libc-dev,
               dbus,
               python3-dbusmock,
               libxcb-composite0-dev,
               libxcb-xfixes0-dev,
               libxcb-render0-dev,
               libxcb-composite0-dev,
               libxcursor-dev,
               libyaml-cpp-dev,
               libwayland-dev,
               libnvidia-egl-wayland-dev,
               eglexternalplatform-dev,
               systemtap-sdt-dev,
               wlcs
Standards-Version: 4.4.0
Homepage: https://mir-server.io/
Vcs-Browser: https://salsa.debian.org/mir-server-team/mir
Vcs-Git: https://salsa.debian.org/mir-server-team/mir.git -b archive-ubuntu

Package: libmirprotobuf3
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - RPC definitions
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared library containing the Google Protobuf definitions
 required for Mir clients and servers.

#TODO: Packaging infrastructure for better dependency generation,
#      ala pkg-xorg's xviddriver:Provides and ABI detection.
Package: libmirserver54
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - server library
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared library needed by server applications for Mir.

Package: libmirplatform21
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - platform library
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the underlying hardware platform.

Package: libmircore-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
Description: Display server for Ubuntu - development headers
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required for server and/or client development.

Package: libmircommon-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmircommon7 (= ${binary:Version}),
         libmircore-dev (= ${binary:Version}),
         libprotobuf-dev (>= 2.4.1),
         libxkbcommon-dev,
         ${misc:Depends},
Breaks: mircommon-dev (<< 0.6)
Replaces: mircommon-dev (<< 0.6)
Description: Display server for Ubuntu - development headers
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required for server and/or client development.

Package: libmirplatform-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmirplatform21 (= ${binary:Version}),
         libmircommon-dev (= ${binary:Version}),
         libboost-program-options-dev,
         ${misc:Depends},
Breaks: libmirplatform (<< 0.6)
Replaces: libmirplatform (<< 0.6)
Description: Display server for Ubuntu - development headers
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required for hardware/driver support development.

Package: libmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmirserver54 (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmircommon-dev (= ${binary:Version}),
         libglm-dev,
         uuid-dev,
         ${misc:Depends},
Description: Display server for Ubuntu - development headers
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required to build Mir servers.

Package: libmirclient10
Section: libs
Architecture: linux-any
Breaks: libmirclient-dev
Replaces: libmirclient-dev
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - client library
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared library needed by client applications for Mir.

Package: mir-demos
Architecture: linux-any
Breaks: miral-examples
Replaces: miral-examples
Provides: miral-examples (=1.5)
Depends: ${misc:Depends},
         ${shlibs:Depends},
         inotify-tools,
Recommends: dmz-cursor-theme,
            fonts-liberation,
            qtwayland5,
            xwayland,
Description: Display server for Ubuntu - demonstration programs
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains demo applications that use the Mir display server

Package: mir-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: API documentation for mir
 This package installs the mir API documentation.

Package: mir-test-tools
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         xwayland,
         glmark2-es2,
         glmark2-es2-wayland,
         mesa-utils-extra,
         dmz-cursor-theme,
Description: Display Server for Ubuntu - test tools
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains tools for smoke and performance testing the Mir display server

Package: mir-wlcs-integration
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Breaks: mir-test-tools (<< 2.2.0-0ubuntu1~)
Replaces: mir-test-tools (<< 2.2.0-0ubuntu1~)
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display Server for Ubuntu - wlcs integration
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains libraries for integration with the wlcs test suite

Package: libmircore1
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - shared library
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server and client.

Package: libmircommon7
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - shared library
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server and client.

# Longer-term these drivers should move out-of-tree
Package: mir-platform-graphics-x19
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - platform library for X11
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the X11 platform.

Package: mir-platform-graphics-gbm-kms19
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - platform library for GBM KMS
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the hardware platform using the Mesa drivers.

Package: mir-platform-graphics-eglstream-kms19
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - platform library for NVIDIA
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the hardware platform using the EGLStream EGL extensions, such as the
 NVIDIA binary driver.

Package: mir-platform-graphics-wayland19
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - platform library for Wayland
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 a "host" Wayland display server.

Package: mir-graphics-drivers-nvidia
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         mir-platform-graphics-eglstream-kms,
         mir-platform-graphics-x,
Description: Display server for Ubuntu - Nvidia driver metapackage
 Mir is a display server running on linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package depends on a full set of graphics and input drivers for Nvidia systems.

Package: mir-platform-input-evdev8
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Display server for Ubuntu - input platform library
 Mir is a display server running on linux systems, with a focus on efficiency,
